%bcond_with tests
Summary:   Fail if tests warn
Name:      perl-Test2-Plugin-NoWarnings
Version:   0.09
Release:   7%{?dist}
License:   Artistic 2.0
URL:       https://metacpan.org/release/Test2-Plugin-NoWarnings
Source0:   https://cpan.metacpan.org/authors/id/D/DR/DROLSKY/Test2-Plugin-NoWarnings-%{version}.tar.gz

BuildRequires: coreutils make perl-generators perl-interpreter perl(warnings)
BuildRequires: perl(ExtUtils::MakeMaker) perl(Carp) perl(parent) perl(strict)
BuildRequires: perl(Test2) perl(Test2::API) perl(Test2::Event) perl(Test2::Util::HashBase)

%if %{with tests}
BuildRequires: perl(File::Spec) perl(IPC::Run3) perl(Test2::Require::Module)
BuildRequires: perl(Test2::V0) perl(Test::More) perl(CPAN::Meta) perl(CPAN::Meta::Prereqs)
%endif
BuildArch:    noarch

%description
Loading this plugin causes your tests to fail if there are any warnings while they run. Each warning
generates a new failing test and the warning content is outputted via diag.

This module uses $SIG{__WARN__}, so if the code you're testing sets this, then this module will stop
working.

%prep
%autosetup -n Test2-Plugin-NoWarnings-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PERLLOCAL=1 NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} -c %{buildroot}

%check
%if %{with tests}
make test
%endif

%files
%license LICENSE
%doc Changes CODE_OF_CONDUCT.md README.md
%{perl_vendorlib}/Test2/
%{_mandir}/man3/Test2::Event::Warning.3*
%{_mandir}/man3/Test2::Plugin::NoWarnings.3*

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.09-7
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.09-6
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.09-5
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 17 2023 Xiaojie Chen <jackxjchen@tencent.com> - 0.09-4
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.09-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.09-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Feb 24 2023 Shuo Wang <abushwang@tencent.com> - 0.09-2
- remove unused buildrequire

* Mon Feb 20 2023 Shuo Wang <abushwang@tencent.com> - 0.09-1
- initial build
